// Fichier libre de droits

// Voici ce que doit fournir une implmentation
// Si template et polymorphisme taient compatibles,
// j'aurais pu imposer que toutes les implmentations en drivent
// du genre en ne dclarant que Solitaire<AbstractImplementation>
//
// Bref, cette classe ne sert  rien, sauf  donner le minimum ncessaire pour
// d'autres implmentations que personne n'implmentera jamais
// (ce qui par ailleurs tombe bien, car je n'aurais pas su
// comment imposer la classe interne Point)

struct AbstractImplementation {
	struct Point { // : public AbstractPoint {
		Point(int, int);
		void display(std::ostream &) const;
	};
	AbstractImplementation();
	~AbstractImplementation();
	bool operator==(const AbstractImplementation &) const;
	bool operator<(const AbstractImplementation &) const;
	bool libre(const Point &) const;
	void retire(const Point &);
	void ajoute(const Point &);
	int taille(void) const;
	void display(std::ostream &, char = 'X') const;
	bool appliqueMouvement(const Mouvement<Point> &);
	void initListeMouvements(void);
	void init(bool, int);

	std::list<Mouvement<Point> > listeMouvements;
	bool isHexagonal;
};
