// Fichier libre de droits

#include <sstream>
#include "Exceptions.h"

CException::CException(const std::string &Message) : m_Message(Message) {
}

CException::~CException() throw() {
}

const char *CException::what() const throw() {
	return m_Message.c_str();
}

CAssertException::CAssertException(const std::string &File, int Line, const std::string &Message) {
	std::ostringstream oss;
	oss << Message << "\tin : " << File << " (" << Line << ")";
	m_Message = oss.str();
}

CLoadingFailed::CLoadingFailed(const std::string &File) {
	std::ostringstream oss;
	oss << "Erreur au chargement de : " << File;
	m_Message = oss.str();
}
