// Fichier libre de droits

#ifndef IMPLEMENTATION32BITS_H
#define IMPLEMENTATION32BITS_H

#include <iostream>
#include <list>

template<class>
struct Mouvement;

template<class integer>
struct ImplementationBit {
	struct Point {
		Point(int = 0, int = 0);
		void display(std::ostream &) const;

		integer descLigne;
		int numeroLigne;
	};

	ImplementationBit();
	~ImplementationBit();
	ImplementationBit &operator=(const ImplementationBit<integer> &);
	ImplementationBit(const ImplementationBit<integer> &);
	bool operator==(const ImplementationBit<integer> &) const;
	bool operator<(const ImplementationBit<integer> &) const;
	bool libre(const Point &) const;
	void retire(const Point &);
	void ajoute(const Point &);
	int taille(void) const;
	void display(std::ostream &, const char * = "X") const;
	void init(bool, int);
	void initListeMouvements(void);
	void swap(ImplementationBit<integer> &);
	static int getMaximumSize(void);

	std::list<Mouvement<Point> > listeMouvements;
private:
	int height;
	integer *lignes;
	bool isHexagonal;
};

template<class integer>
inline std::ostream &operator<<(std::ostream &os, const typename ImplementationBit<integer>::Point &p) {
	p.display(os);
	return os;
}

#endif // IMPLEMENTATION32BITS_H
