// Fichier libre de droits

#ifndef IMPLEMENTATIONLISTE_H
#define IMPLEMENTATIONLISTE_H

#include <iostream>
#include <list>
#include <set>

template<class>
struct Mouvement;

struct ImplementationListe {
	struct Point {
		Point(int = 0, int = 0);
		void display(std::ostream &) const;
		bool operator!=(const Point &) const;
		bool operator<(const Point &) const;

		int ligne;
		int colonne;
	};

	ImplementationListe();
	ImplementationListe(const ImplementationListe &);
	ImplementationListe &operator=(const ImplementationListe &);
	bool operator==(const ImplementationListe &) const;
	bool operator<(const ImplementationListe &) const;
	void display(std::ostream &, const char * = "X") const;
	bool appliqueMouvement(const Mouvement<Point> &);
	bool libre(const Point &) const;
	void retire(const Point &);
	void ajoute(const Point &);
	int taille(void) const;
	void initListeMouvements(void);
	void init(bool, int);
	void swap(ImplementationListe &);

	std::list<Mouvement<Point> > listeMouvements;
private:
	std::set<Point> desc;
	bool isHexagonal;
};

inline std::ostream &operator<<(std::ostream &os, const ImplementationListe::Point &p) {
	p.display(os);
	return os;
}

#endif // IMPLEMENTATIONLISTE_H
