// Fichier libre de droits

#ifndef MOUVEMENT_H
#define MOUVEMENT_H

#include <iostream>

template<class Point>
struct Mouvement {
	Mouvement();
	Mouvement(const Point &, const Point &, const Point &);
	void display(std::ostream &) const;
	const Point &getOrigine1(void) const;
	const Point &getOrigine2(void) const;
	const Point &getDestination(void) const;
private:
	Point origine1;
	Point origine2;
	Point destination;
};

template<class Point>
Mouvement<Point>::Mouvement(const Point &orig1, const Point &orig2, const Point &dest) : origine1(orig1), origine2(orig2), destination(dest) {
}

template<class Point>
void Mouvement<Point>::display(std::ostream &os) const {
	os << origine1 << " + " << origine2 << " -> " << destination;
}

template<class Point>
const Point &Mouvement<Point>::getOrigine1(void) const {
	return origine1;
}

template<class Point>
const Point &Mouvement<Point>::getOrigine2(void) const {
	return origine2;
}

template<class Point>
const Point &Mouvement<Point>::getDestination(void) const {
	return destination;
}

template<class Point>
inline std::ostream &operator<<(std::ostream &os, const Mouvement<Point> &m) {
	m.display(os);
	return os;
}

template<class Point>
Mouvement<Point>::Mouvement() {
}

#endif // MOUVEMENT_H
